
Foreman - Bug #18777

Can not delete host if VM is removed

03/02/2017 09:21 AM - Torben Hørup

Status: New   

Priority: Normal   

Assignee:    

Category: Compute resources   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Using foreman 1.14.1

foreman_xen 0.5.1-2

Steps to reproduce.

Create host via foreman.

Delete vm on compute resource directly (via XenCenter)

Try to remove host in foreman - this fails with exception:

2017-03-02T15:18:34 bbb97604 [app] [W] Failed to fetch power status  | NoMethodError: undefined method `ready?' for nil:NilClass 

| /usr/share/foreman/app/services/power_manager/virt.rb:33:in `default_action'  |

/usr/share/foreman/app/services/power_manager/base.rb:25:in `block (2 levels) in <class:Base>'  |

/usr/share/foreman/app/models/concerns/hostext/power_interface.rb:22:in `supports_power_and_running?'  |

/usr/share/foreman/app/controllers/hosts_controller.rb:973:in `block in host_power_ping'  | /usr/lib/ruby/2.1.0/timeout.rb:91:in `block in

timeout'  | /usr/lib/ruby/2.1.0/timeout.rb:35:in `block in catch'  | /usr/lib/ruby/2.1.0/timeout.rb:35:in `catch'  |

/usr/lib/ruby/2.1.0/timeout.rb:35:in `catch'  | /usr/lib/ruby/2.1.0/timeout.rb:106:in `timeout'  |

/usr/share/foreman/app/controllers/hosts_controller.rb:972:in `host_power_ping'  |

/usr/share/foreman/app/controllers/hosts_controller.rb:279:in `get_power_state'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal/implicit_render.rb:4:in `send_action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/abstract_controller/base.rb:198:in `process_action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal/rendering.rb:10:in `process_action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/abstract_controller/callbacks.rb:20:in `block in process_action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:117:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:117:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:555:in `block (2 levels) in compile'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:498:in `block (2 levels) in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `block (2 levels) in halting'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rails-observers-0.1.2/lib/rails/observers/action_controller/caching/sweeping.rb:73:in

`around'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:455:in `public_send'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:455:in `block in make_lambda'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `block in halting'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `block in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:498:in `block (2 levels) in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `block (2 levels) in halting'  |

/usr/share/foreman/app/controllers/concerns/application_shared.rb:14:in `set_timezone'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:432:in `block in make_lambda'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `block in halting'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `call'  |
/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `block in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:498:in `block (2 levels) in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `block (2 levels) in halting'  |

/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in `clear_thread'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:432:in `block in make_lambda'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `block in halting'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `block in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:498:in `block (2 levels) in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:313:in `block (2 levels) in halting'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rails-observers-0.1.2/lib/rails/observers/action_controller/caching/sweeping.rb:73:in

`around'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:455:in `public_send'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:455:in `block in make_lambda'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:312:in `block in halting'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:497:in `block in around'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:505:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:92:in `__run_callbacks__'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:778:in

`_run_process_action_callbacks'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:81:in `run_callbacks'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/abstract_controller/callbacks.rb:19:in `process_action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal/rescue.rb:29:in `process_action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal/instrumentation.rb:32:in `block in

process_action'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/notifications.rb:164:in `block in

instrument'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/notifications/instrumenter.rb:20:in

`instrument'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/notifications.rb:164:in `instrument' 

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal/instrumentation.rb:30:in `process_action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal/params_wrapper.rb:250:in `process_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-4.2.7.1/lib/active_record/railties/controller_runtime.rb:18:in

`process_action'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/abstract_controller/base.rb:137:in `process'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionview-4.2.7.1/lib/action_view/rendering.rb:30:in `process'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal.rb:196:in `dispatch'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal/rack_delegation.rb:13:in `dispatch'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_controller/metal.rb:237:in `block in action'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/routing/route_set.rb:74:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/routing/route_set.rb:74:in `dispatch'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/routing/route_set.rb:43:in `serve'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/journey/router.rb:43:in `block in serve'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/journey/router.rb:30:in `each'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/journey/router.rb:30:in `serve'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/routing/route_set.rb:817:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/apipie-rails-0.3.7/lib/apipie/static_dispatcher.rb:65:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/apipie-rails-0.3.7/lib/apipie/extractor/recorder.rb:132:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/apipie-rails-0.3.7/lib/apipie/middleware/checksum_in_headers.rb:27:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/etag.rb:24:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/conditionalget.rb:25:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/head.rb:13:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/params_parser.rb:27:in `call'  |

/usr/share/foreman/lib/middleware/catch_json_parse_errors.rb:8:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/flash.rb:260:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/session/abstract/id.rb:225:in `context'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/session/abstract/id.rb:220:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/cookies.rb:560:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-4.2.7.1/lib/active_record/query_cache.rb:36:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-4.2.7.1/lib/active_record/connection_adapters/abstract/connection_pool.rb:6

53:in `call'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/callbacks.rb:29:in `block

in call'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:88:in `__run_callbacks__'  |
/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:778:in `_run_call_callbacks'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/callbacks.rb:81:in `run_callbacks'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/callbacks.rb:27:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/remote_ip.rb:78:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/debug_exceptions.rb:17:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/show_exceptions.rb:30:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/railties-4.2.7.1/lib/rails/rack/logger.rb:38:in `call_app'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/railties-4.2.7.1/lib/rails/rack/logger.rb:22:in `call'  |

/usr/share/foreman/lib/middleware/tagged_logging.rb:18:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/request_id.rb:21:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/methodoverride.rb:22:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/runtime.rb:18:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-4.2.7.1/lib/active_support/cache/strategy/local_cache_middleware.rb:28:in

`call'  | /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-4.2.7.1/lib/action_dispatch/middleware/static.rb:120:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/sendfile.rb:113:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/secure_headers-3.6.1/lib/secure_headers/middleware.rb:12:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/railties-4.2.7.1/lib/rails/engine.rb:518:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/railties-4.2.7.1/lib/rails/application.rb:165:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/railties-4.2.7.1/lib/rails/railtie.rb:194:in `public_send'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/railties-4.2.7.1/lib/rails/railtie.rb:194:in `method_missing'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/urlmap.rb:66:in `block in call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/urlmap.rb:50:in `each'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.6.5/lib/rack/urlmap.rb:50:in `call'  |

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/thread_handler_extension.rb:74:in `process_request'  |

/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:141:in `accept_and_process_next_request'  |

/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:109:in `main_loop'  |

/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler.rb:455:in `block (3 levels) in start_threads'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/logging-2.1.0/lib/logging/diagnostic_context.rb:450:in `call'  |

/usr/share/foreman/vendor/ruby/2.1.0/gems/logging-2.1.0/lib/logging/diagnostic_context.rb:450:in `block in

create_with_logging_context'

Related issues:

Related to Foreman - Bug #22143: WebUI doesn't allow to delete a host provisi... Closed

History

#1 - 03/02/2017 09:40 AM - Anonymous

This is more less expected. Try to de-associate the VM from the host first (Host -> Edit -> Disassociate Host)

#2 - 03/02/2017 10:18 AM - Torben Hørup

Update. It works if you de-associate the hosts first.

But maybe it could provide a better error message than

"Error: Failed to destroy a compute xen (Xenserver) instance benny-schulle: undefined method `destroy' for nil:NilClass"

#3 - 03/02/2017 10:49 AM - Anonymous

- Project changed from Xen to Foreman

- Subject changed from Can not delete host if vm is removed to Can not delete host if VM is removed

- Category set to Compute resources

But maybe it could provide a better error message

 That's a more than valid point. As this issue is a general problem in Foreman and not related to a specific compute resource, moving the issue.

#4 - 01/04/2018 09:46 AM - Ivan Necas

- Related to Bug #22143: WebUI doesn't allow to delete a host provisioned via bootdisk from satellite, when same host has already been deleted from

rhev added

#5 - 01/07/2018 06:22 AM - Ido Kanner

- Assignee set to Ido Kanner
#6 - 05/27/2018 11:49 AM - Anonymous

Ido, was there any progress? If no, please unassign the ticket.

#7 - 05/28/2018 04:07 AM - Ido Kanner

- Assignee deleted (Ido Kanner)

removing myself following Mike's request
